grammar Language2_infix_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

expression : exp EOF {System.out.println($exp.tree.toStringTree());}
           ;

exp : term ( '+'^ term | '-'^ term )*
    ;

term : signed ( '*'^ signed | '/'^ signed | '%'^ signed )*
     ;

signed : ('-'^)? factor
       ;

factor : base ('^'^ signed )?
       ;

base : '('! exp ')'!
     | INTEGER
     ;

INTEGER : '0'..'9'+
        ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
