tree grammar Language2_infix_AST_eval;

options
{
   tokenVocab=Language2_infix_AST;
   ASTLabelType=CommonTree;
}

expression returns [int result]
           : exp {$result=$exp.result;} EOF
           ;

exp returns [int result]
  :   ^('+' a=exp b=exp) {$result = a+b;}
  |   ^('-' a=exp (b=exp {$result = a-b;}
                  |      {$result = -a;}
                  ) )
  |   ^('*' a=exp b=exp) {$result = a*b;}
  |   ^('/' a=exp b=exp) {$result = a/b;}
  |   ^('%' a=exp b=exp) {$result = a\%b;}   /* % needs an escape */
  |   ^('^' a=exp b=exp) {$result = (int)Math.pow(a,b);}
  |   INTEGER            {$result = Integer.parseInt($INTEGER.text);}
  ;

