grammar Language2_infix_eval;

expression returns [int result]
           : exp {$result=$exp.result;} EOF
           ;

exp returns [int result]
    : r=term {$result=$r.result;} ( '+' r=term {$result += $r.result;}
                                  | '-' r=term {$result -= $r.result;}
                                  )*
    ;

term returns [int result]
     : r=signed {$result=$r.result;} ( '*' r=signed {$result *= $r.result;}
                                     | '/' r=signed {$result /= $r.result;}
                                     | '%' r=signed {$result \%= $r.result;}
                                     )*
     ;

signed returns [int result]
       :  '-'  r=factor {$result = -$r.result;}
       |       r=factor {$result =  $r.result;}
       ;

factor returns [int result]
       : base {$result=$base.result;}('^' r=signed {$result=(int)Math.pow($result,$r.result);})?
       ;

base returns [int result]
     : '(' exp ')' {$result = $exp.result;}
     | INTEGER     {$result = Integer.parseInt($INTEGER.text);}
     ;

INTEGER : '0'..'9'+
        ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
