/*
  This program tests the lexer and parser created
  by Antlr from the grammar Language2_infix_eval.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;

public class TestParser_eval
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "1 + 2 + 3",
         "( 1 + 2 + 3 )",
         "1 + x",
         "2 * ( 3 + 4 )",
         "2 ^ 3 ^ 4",
         "3 * 4 + 5 * 6 + - 4",
         "- ( 3 * 4 )",
         "- 3 ^ ( 1 + 2 )",
         "( 6 % 2 ) + ( 8 % 2 ) + ( 3 % 2 )",
         "( 1 + 2 ) ^ ( 4 * 5 )"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language2_infix_evalLexer lexer = new Language2_infix_evalLexer(new ANTLRStringStream(exprs[i]));
         Language2_infix_evalParser parser = new Language2_infix_evalParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is an int.
            int result = parser.expression();
            System.out.println("result = " + result );
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_eval
