/*
  This program demonstrates how difficult it is in languages like
  Java (or C or C++) to instantiate a complex data structure like
  a binary tree. Below is code that instantiates the following tree.


                 a
                / \
              /     \
             b       c
            / \        \
          /     \        \
         d       e        f
                         /
                       /
                      g
                       \
                         \
                           h
*/

public class Example1
{
   public static void main(String[] args)
   {
      BTree btree = new BTree("a", new BTree("b", new BTree("d"), new BTree("e")), new BTree("c", null, new BTree("f", new BTree("g", null, new BTree("h")), null)));

/*
      BTree btree = new BTree("a",
                              new BTree("b",
                                        new BTree("d"),
                                        new BTree("e")),
                              new BTree("c",
                                        null,
                                        new BTree("f",
                                                  new BTree("g",
                                                            null,
                                                            new BTree("h")),
                                                  null)) );
*/

      // Let us traverse the tree so that we can convince
      // ourselves that it was constructed correctly.
      // We should get "d b e a c g h f".
      System.out.println( "  In-order traversal = " + Traverse.inOrder( btree ) + "\n" );
      System.out.println( " Pre-order traversal = " + Traverse.preOrder( btree ) + "\n" );
      System.out.println( "Post-order traversal = " + Traverse.postOrder( btree ) + "\n" );

   }//main

}//Example1
