/*
   This program parses, type checks, and then evaluates strings from Language-14t.
*/

public class Examples
{
   public static void main(String[] args)
   {
      String expr1 =
         "( prog " +
           "( + 1000 " +
               "( ( lambda ( signature int int bool ) n b ( if b n 0 ) ) 100 false ) ) )";


      String expr2 =
      "( prog " +
        "( var ( signature int ( signature int int int ) int int int int ) reduce " +
           "( lambda  ( signature int ( signature int int int ) int int int int ) op w x y z " +
                 "( op w ( op x ( op y z ) ) ) ) ) " +
        "( print ( reduce + 1 2 3 4 ) ) " +
        "( print ( reduce * 1 2 3 4 ) ) " +
        "( print ( reduce ( lambda ( signature int int int ) u v ( * u v ) ) 1 2 3 4 ) ) )";


      String expr3 = "( prog " +
                       "( var ( signature ( signature int int ) int ) add " +
                           "( lambda  ( signature ( signature int int ) int ) x " +
                             "( lambda ( signature int int ) y ( + x y ) ) ) ) " +
                       "( ( add 2 ) 3 ) )"; // add returns a function


      String expr4 = "( prog " +
                       "( var ( signature ( signature int int ) int ) incrementBy " +
                           "( lambda ( signature ( signature int int ) int ) x " +
                                  "( lambda ( signature int int ) y ( + y x ) ) ) ) " +
                       "( var ( signature int int ) incrementBy2 ( incrementBy 2 ) ) " +
                       "( var ( signature int int ) incrementBy3 ( incrementBy 3 ) ) " +
                       "( print ( var int n1 ( incrementBy2 10 ) ) ) " +
                       "( print ( set n1 ( incrementBy2 n1 ) ) ) " +
                       "( print ( set n1 ( incrementBy3 n1 ) ) ) " +
                       "( print ( set n1 ( incrementBy3 n1 ) ) ) " +
                       "( print ( set n1 ( incrementBy2 n1 ) ) ) )";

      String expr0 = "( prog ( * ( + ( * 2 ( print 3 ) ) ( / 6 3 ) ) ( + 3 ( neg ( + 2 2 ) ) ) )   )";


      String expr = expr0;

      // print the original expression
      System.out.println( expr + "\n" );

      // preporcess the expression
      expr = Preprocessor.preprocess(expr);

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the preprocessed expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // run the type checker
         if ( TypeChecker.typeCheck( ast ) )
         {
            TypeRemoval.removeTypes( ast );

            // pretty-print the abstract syntax tree
            System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );

            // evaluate the expression (interpret the AST)
            Value value = Evaluate.evaluate( ast );

            System.out.println( "result = " + value );
         }
         else
         {
            System.out.println("There were type errors.");
         }
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples