/*
   This program parses and then evaluates strings from Language-14.
*/

public class Examples
{
   public static void main(String[] args)
   {
      String expr1 = "( prog " +
                       "( var reduce " +
                           "( lambda  op w x y z " +  // op is a function parameter
                             "( op w x y z ) ) ) " +
                       "( print ( reduce + 1 2 3 4 ) ) " +
                       "( print ( reduce * 1 2 3 4 ) ) )";




      String expr = expr1;

      // print the original expression
      System.out.println( expr + "\n" );

      // preporcess the expression
      expr = Preprocessor.preprocess(expr);

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the preprocessed expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples