/*
   This program parses and then evaluates strings from Language-7.
*/

public class Examples
{
   public static void main(String[] args)
   {
      String expr1 = "( prog " +
                       "( define f ( lambda x ( * x x ) ) ) " +
                       "( apply f 5 ) )";

      String expr2 = "( prog " +
                       "( define f ( lambda x ( * x x ) ) ) " +
                       "( define g ( lambda x ( + x ( apply f x ) ) ) ) " +
                       "( apply g 5 ) )";


      String expr3 = "( prog " +
                       "( define w 10 ) " +
                       "( define f ( lambda x ( * x x ) ) ) " +
                       "( define z ( begin " +
                                    "( var x 0 ) " +
                                    "( begin ( var y 2 ) " +
                                            "( begin " +
                                              "( set x w ) " +
                                              "( apply f ( + x y ) ) ) ) ) ) " +
                       "z )";


      // Use the next two examples to see the difference
      // between dynamic scope and static scope.
      String expr4 = "( prog " +
                       "( define n 1 ) " +
                       "( define f ( lambda x ( * n x ) ) ) " +
                       "( define g ( lambda x ( begin " +
                                               "( var n 5 ) " +
                                               "( apply f x ) ) ) ) " +
                       "( apply g 2 ) )";

      String expr5 = "( prog " +
                       "( define n 1 ) " +
                       "( define f ( lambda x ( * n x ) ) ) " +
                       "( define g ( lambda x ( begin " +
                                               "( var n 5 ) " +
                                               "( var r ( apply f x ) ) " +
                                               "r ) ) ) " +
                       "( apply g 2 ) )";


      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples