/*
   This program parses and then evaluates strings from Language-6.
*/

public class Examples
{
   public static void main(String[] args)
   {
      String expr1 = "( begin " +
                       "( var x 0 ) " +
                       "( begin ( var y 2 ) " +
                               "( begin " +
                                 "( set x 3 ) " +
                                 "( var y ( + x y ) ) ) ) )";

      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      BTree ast = BuildBTree.buildBTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
       // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      // evaluate the expression (interpret the AST)
      Value value = Evaluate.evaluate( ast );

      System.out.println( "result = " + value );
   }//main

}//Examples
