/*
   This program parses and then evaluates strings from Language-8.

   These two examples demonstrate two ways that a function can be
   used as a first class vlaue.
   (1) A function can be passed as a parameter to another function.
   (2) A function can be returned by another function
*/

public class Examples
{
   public static void main(String[] args)
   {
      String expr1 = "( prog " +
                       "( define x 5 ) " +
                       "( define f ( lambda x ( * x x ) ) ) " +
                       "( define g ( lambda h ( apply h x ) ) ) " +
                       "( apply g f ) )";


      String expr2 = "( prog " +
                       "( define f ( lambda x ( * x x ) ) ) " +
                       "( define g ( lambda x f ) ) " +
                       "( begin " +
                         "( var h ( apply g 0 ) ) " +
                         "( apply h 5 ) ) )";


      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
       // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples