/*

*/

public class Examples2
{
   public static void main(String[] args)
   {

      String expr1 = "( prog " +       // mutually recursive functions
                        "( var even ( lambda n " +
                                        "( if ( == n 0 ) " +
                                             "true " +
                                             "( if ( == n 1 ) " +
                                                  "false " +
                                                  "( odd ( - n 1 ) ) ) ) ) ) " +
                        "( var odd ( lambda n " +
                                       "( if ( == n 1 ) " +
                                            "true " +
                                             "( if ( == n 0 ) " +
                                                  "false " +
                                                  "( even ( - n 1 ) ) ) ) ) ) " +
                        "( even 5 ) )";

      String expr = expr1;

      // print the original expression
      System.out.println( expr + "\n" );

      // preporcess the expression
      expr = Preprocessor.preprocess(expr);

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the preprocessed expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "\nresult = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main
}//Examples2
