tree grammar Language2_AST_eval;

options
{
   tokenVocab=Language2_AST;
   ASTLabelType=CommonTree;
}

expression returns [int result]
           : exp EOF {$result=$exp.result;}
           ;

exp returns [int result]
    : ^('+' a=exp b=exp) {$result = a + b;}
    | ^('-' a=exp b=exp) {$result = a - b;}
    | ^('*' a=exp b=exp) {$result = a * b;}
    | ^('/' a=exp b=exp) {$result = a / b;}
    | ^('%' a=exp b=exp) {$result = a \% b;}   /* % needs to be escaped! */
    | ^('^' a=exp b=exp) {$result = (int)Math.pow(a,b);}
    | INTEGER            {$result = Integer.parseInt($INTEGER.text);}
    ;

