grammar Language2_eval;







expression returns [int result]
           : exp EOF {$result=$exp.result;}
           ;

exp returns [int result]
    : '(' '+' a=exp b=exp ')' {$result = $a.result + $b.result;}
    | '(' '-' a=exp b=exp ')' {$result = $a.result - $b.result;}
    | '(' '*' a=exp b=exp ')' {$result = $a.result * $b.result;}
    | '(' '/' a=exp b=exp ')' {$result = $a.result / $b.result;}
    | '(' '%' a=exp b=exp ')' {$result = $a.result \% $b.result;} /* % needs to be escaped! */
    | '(' '^' a=exp b=exp ')' {$result = (int)Math.pow($a.result, $b.result);}
    | INTEGER                 {$result = Integer.parseInt($INTEGER.text);}
    ;

binOp : '+' | '-' | '*' | '/' | '%' | '^'
      ;

INTEGER : '0'..'9'+
        ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
