grammar Language4_infix_AST;

options
{
   output=AST;
   ASTLabelType=CommonTree;
}

tokens { BEGIN; VAR; } /* declare two "imaginary tokens" */

 expression returns [String result]
            : exp EOF {$result=$exp.tree.toStringTree();}
            ;

        exp :  begin | var | abexp
            ;

      begin : '{' exp ( ';' exp )* '}' -> ^(BEGIN exp exp*)
            ;

        var : VARIABLE '=' exp -> ^(VAR VARIABLE exp)
            ;

      abexp : abterm ( '||'^ abterm )*
            ;

     abterm : efactor ( '&&'^ efactor )*
            ;

    efactor : rfactor ( '=='^ rfactor | '!='^ rfactor )*
            ;

    rfactor : aexp ( relOp  aexp )?
            ;

      relOp : '<'^ | '>'^ | '<='^ | '>='^
            ;

       aexp : term ( '+'^ term | '-'^ term )*
            ;

       term : signed ( '*'^ signed | '/'^ signed | '%'^ signed )*
            ;

     signed : ( '-'^ | '+'^ | '!'^ )? factor
            ;

     factor : base ( '^'^ signed )?
            ;

       base : '('! abexp ')'!
            | INTEGER
            | BOOLEAN
            | VARIABLE
            ;

    INTEGER : '0'..'9'+
            ;

    BOOLEAN : 'false' | 'true'
            ;

   VARIABLE : ('a'..'z')+
            ;

         WS : (' '|'\t'|'\n'|'\r')+ {skip();}
            ;
