/**
   The prettyPrint() method takes a BTree and
   converts it into a well formated string.


*/


public class PrettyPrinter
{
   public static String prettyPrint(BTree tree)
   {
      return prettyPrint(tree, "");
   }

   /**
      This prettyPrint() method is essentially a pre-order
      traversal of the tree.
   */
   private static String prettyPrint(BTree tree, String indentation)
   {
      String result = "";

      if ( tree.degree() == 0)  // constant term (stops the recursion)
         result += indentation + tree.getElement();
      else
      {
         result += indentation + "(" + tree.getElement() + "\n";

         if ( tree.getLeftTree() != null )
            result += prettyPrint( tree.getLeftTree(), indentation+"  " ) + "\n";
         else
            result += indentation + "  ()\n";
         if ( tree.getRightTree() != null )
            result += prettyPrint( tree.getRightTree(), indentation+"  " ) + "\n";
         else
            result += indentation + "  ()\n";

         result += indentation + ")";
      }
      return result;
   }

}//PrettyPrinter