/*
  This program tests the lexer and parser created
  by Antlr from the grammar Language1.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "(a(b c d)e)",
         "( a ( b c d ) e )",
         "(a b c d e)",
         "(a b(c d e))",
         "(a (b c) (d e))",
         "(a(b(c(d e))))",
         "(a (b c a) (a (d e) (f a (g a a))))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language1Lexer lexer = new Language1Lexer(new ANTLRStringStream(exprs[i]));
         Language1Parser parser = new Language1Parser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            parser.stree();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser
