/*
   This program tests the lexer and parser created
   by Antlr from the grammar Language1.g.
*/
import org.antlr.runtime.*;

public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "(a(b c d)e)",
         "( a ( b c d ) e )",
         "(a b c d e)",
         "(a b(c d e))",
         "(a (b c) (d e))",
         "(a(b(c(d e))))",
         "(a (b c d e))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language1Lexer lexer = new Language1Lexer(new ANTLRStringStream(exprs[i]));
         Language1Parser parser = new Language1Parser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            int r = parser.stree();
            System.out.println("Number of leaf nodes = " + r );
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser
