/*
  This program tests the lexer and parser created
  by Antlr from the grammar UnaryMinus.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;


public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "-2",
         "2 - 3",
         "3 - 2",
         "3 - -2",
         "-3 - 2",
         "-3 - -2",
         "1 - -1 - -1 - 1 - 1 - 1"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         UnaryMinusLexer  lexer  = new UnaryMinusLexer(new ANTLRStringStream(exprs[i]));
         UnaryMinusParser parser = new UnaryMinusParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // Start the parser at the start rule "expression".
            parser.expression();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser
