/*
  This program tests the lexers and parsers created
  by Antlr from the grammars Language2_AST.g and Language2_AST_eval.g

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestParser_AST_eval
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "(+(+1 2)3)",
         "(+ (+ 1 2) 3)",
         "(+ 1 x)",
         "(*2(+3 4))",
         "(^ 2 (^ 3 4))",
         "(+ (+ (*3 4) (*5 6)) (- 0 4))",
         "(- (* 3 4))",
         "(^ (- 3) (+ 1 2))",
         "(- (+ (% 6 2) (% 8 2)) (% 3 2))",
         "(^(+ 1 2)(* 4 5))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language2_ASTLexer lexer = new Language2_ASTLexer(new ANTLRStringStream(exprs[i]));
         Language2_ASTParser parser = new Language2_ASTParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is a tree.
            Language2_ASTParser.expression_return r = parser.expression();
            CommonTree tree = (CommonTree)r.getTree();
            System.out.println( tree.toStringTree() );

            // Walk the resulting tree.
            // Create a tree node stream from the resulting tree.
            CommonTreeNodeStream nodes = new CommonTreeNodeStream(tree);
            // Create a tree parser.
            Language2_AST_eval walker = new Language2_AST_eval(nodes);
            // Launch the tree walker at the start rule "expression".
            int result = walker.expression();
            System.out.println("result = " + result);
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_AST_eval
