/*
  This program tests the lexer and parser created
  by Antlr from the grammar UnaryMinus_AST.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestParser_AST_ver2
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "-2",
         "2 - 3",
         "3 - 2",
         "3 - -2",
         "-3 - 2",
         "-3 - -2",
         "1 - -1 - -1 - 1 - 1 - 1"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         UnaryMinus_AST_ver2Lexer  lexer  = new UnaryMinus_AST_ver2Lexer(new ANTLRStringStream(exprs[i]));
         UnaryMinus_AST_ver2Parser parser = new UnaryMinus_AST_ver2Parser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is a tree.
            UnaryMinus_AST_ver2Parser.expression_return r = parser.expression();
            CommonTree tree = (CommonTree)r.getTree();
            System.out.println( tree.toStringTree() );
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_AST_ver2
