/**
   The preOrder() method prints out an pre-order
   traversal of the nodes of a BTree.

   The inOrder() method prints out an in-order
   traversal of the nodes of a BTree.

   The postOrder() method prints out an post-order
   traversal of the nodes of a BTree.
*/

public class Traverse
{
   public static String preOrder(BTree tree)
   {
      String result = "";

      result += tree.getElement() + " ";

      if ( tree.getLeftTree() != null )
         result += preOrder( tree.getLeftTree() );

      if ( tree.getRightTree() != null )
         result += preOrder( tree.getRightTree() );

      return result;
   }


   public static String inOrder(BTree tree)
   {
      String result = "";

      if ( tree.getLeftTree() != null )
         result += inOrder( tree.getLeftTree() );

      result += tree.getElement() + " ";

      if ( tree.getRightTree() != null )
         result += inOrder( tree.getRightTree() );

      return result;
   }


   public static String postOrder(BTree tree)
   {
      String result = "";

      if ( tree.getLeftTree() != null )
         result += postOrder( tree.getLeftTree() );

      if ( tree.getRightTree() != null )
         result += postOrder( tree.getRightTree() );

      result += tree.getElement() + " ";

      return result;
   }

}//Traverse