/*

*/

class Value
{
   public:
     std::string * tag;    // either "int" or "bool" or "lambda"
     int valueI;
     bool valueB;
     IPEP valueL;

   public:
   /*
      Construct a Value object that holds an int value.
   */
   Value(std::string* newTag, int value)
   {
      if (0==newTag->compare("int"))
      {
         tag = newTag;
         valueI = value;
         valueB = false;
         valueL.ip = NULL;
         valueL.ep = NULL;
      }
      else
         throw "invalid value tag: " + *tag;
   }

   /*
      Construct a Value object that holds a boolean value.
   */
   Value(std::string* newTag, bool value)
   {
      if (0==newTag->compare("bool"))
      {
         tag = newTag;
         valueI = 0;
         valueB = value;
         valueL.ip = NULL;
         valueL.ep = NULL;
      }
      else
         throw "invalid value tag: " + *tag;
   }

   /*
      Construct a Value object that holds a lambda value.
   */
   Value(std::string* newTag, IPEP value)
   {
      if (0==newTag->compare("lambda"))
      {
         tag = newTag;
         valueI = 0;
         valueB = false;
         valueL = value;
      }
      else
         throw "invalid value tag: " + *tag;
   }

   /*
      A default constructor.
   */
   Value()
   {
         tag = NULL;
         valueI = 0;
         valueB = false;
         valueL.ip = NULL;
         valueL.ep = NULL;
   }

   /*
      Use this operator for information purposes.
   */
   friend std::ostream& operator<<(std::ostream& os, const Value& v)
   {
      os << "[tag->" << *(v.tag)
           << ", valueI->" << v.valueI
           << ", valueB->" << v.valueB
           << ", valueL->{ip=" << v.valueL.ip << ",ep=" << v.valueL.ep << "}]";
      return os;
   }

};//Value
