/**

*/

public class Value
{
   public String tag;    // either "int" or "bool"
   public int valueI=0;
   public boolean valueB=false;

   /**
      Construct a Value object that holds a default value
      of the appropriate type.
   */
   public Value(String tag)
   {
      if (tag.equals("int"))
      {
         this.tag = tag;
         valueI = 0;     // default value for type int
      }
      else if (tag.equals("bool"))
      {
         this.tag = tag;
         valueB = false; // default value for type bool
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds an int value.
   */
   public Value(String tag, int value)
   {
      if (tag.equals("int"))
      {
         this.tag = tag;
         valueI = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds a boolean value.
   */
   public Value(String tag, boolean value)
   {
      if (tag.equals("bool"))
      {
         this.tag = tag;
         valueB = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   public String toString()
   {
      return "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + "]";
   }

/*
   public String toString()
   {
      String result = "";

      if ( tag.equals("bool") )
      {
         result += valueB;
      }
      else if ( tag.equals("int") )
      {
         result += valueI;
      }
      else  // bad tag (shouldn't get here)
      {
         result += "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + "]";
      }

      return result;
   }
*/
}//Value