/**

*/

public class Value
{
   public String tag;    // either "int", "bool", "closure", "builtin"
   public int valueI=0;
   public boolean valueB=false;
   public IPEP valueC=null;
   public String valueBi=null;

   /**
      Construct a Value object that holds an int value.
   */
   public Value(String tag, int value)
   {
      if (tag.equals("int"))
      {
         this.tag = tag;
         valueI = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds a boolean value.
   */
   public Value(String tag, boolean value)
   {
      if (tag.equals("bool"))
      {
         this.tag = tag;
         valueB = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds a closure value.
   */
   public Value(String tag, IPEP value)
   {
      if (tag.equals("closure"))
      {
         this.tag = tag;
         valueC = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds a builtin value.
   */
   public Value(String tag, String value)
   {
      if (tag.equals("builtin"))
      {
         this.tag = tag;
         valueBi = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   public String toString()
   {
      return "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + ", valueC->" + valueC + ", valueBi->" + valueBi + "]";
   }

/*
   public String toString()
   {
      String result = "";

      if ( tag.equals("bool") )
      {
         result += valueB;
      }
      else if ( tag.equals("int") )
      {
         result += valueI;
      }
      else if ( tag.equals("closure") )
      {
         result += valueC;
      }
      else if ( tag.equals("builtin") )
      {
         result += valueBi;
      }
      else  // bad tag (shouldn't get here)
      {
         result += "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + ", valueC->" + valueC + ", valueBi->" + valueBi + "]";
      }

      return result;
   }
*/
}//Value