/*
  This program tests the lexers and parsers created
  by Antlr from the grammars Language1_*.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;


public class TestParser_eval
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "(a(b c d)e)",
         "( a ( b c d ) e )",
         "(a b c d e)",
         "(a b(c d e))",
         "(a (b c) (d e))",
         "(a(b(c(d e))))",
         "(a (b c a) (a (d e) (f a (g a a))))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language1_depthLexer lexer1 = new Language1_depthLexer(new ANTLRStringStream(exprs[i]));
         Language1_depthParser parser1 = new Language1_depthParser(new CommonTokenStream(lexer1));

         Language1_count_nodesLexer lexer2 = new Language1_count_nodesLexer(new ANTLRStringStream(exprs[i]));
         Language1_count_nodesParser parser2 = new Language1_count_nodesParser(new CommonTokenStream(lexer2));

         Language1_count_leavesLexer lexer3 = new Language1_count_leavesLexer(new ANTLRStringStream(exprs[i]));
         Language1_count_leavesParser parser3 = new Language1_count_leavesParser(new CommonTokenStream(lexer3));

         Language1_max_degreeLexer lexer4 = new Language1_max_degreeLexer(new ANTLRStringStream(exprs[i]));
         Language1_max_degreeParser parser4 = new Language1_max_degreeParser(new CommonTokenStream(lexer4));

         Language1_count_rootLexer lexer5 = new Language1_count_rootLexer(new ANTLRStringStream(exprs[i]));
         Language1_count_rootParser parser5 = new Language1_count_rootParser(new CommonTokenStream(lexer5));

         Language1_DFS_preorderLexer lexer6 = new Language1_DFS_preorderLexer(new ANTLRStringStream(exprs[i]));
         Language1_DFS_preorderParser parser6 = new Language1_DFS_preorderParser(new CommonTokenStream(lexer6));

         Language1_DFS_inorderLexer lexer7 = new Language1_DFS_inorderLexer(new ANTLRStringStream(exprs[i]));
         Language1_DFS_inorderParser parser7 = new Language1_DFS_inorderParser(new CommonTokenStream(lexer7));

         Language1_DFS_postorderLexer lexer8 = new Language1_DFS_postorderLexer(new ANTLRStringStream(exprs[i]));
         Language1_DFS_postorderParser parser8 = new Language1_DFS_postorderParser(new CommonTokenStream(lexer8));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            parser1.stree();
            parser2.stree();
            parser3.stree();
            parser4.stree();
            parser5.stree();
            parser6.stree();
            parser7.stree();
            parser8.stree();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_eval
