/*
  This program tests the lexers and parsers created
  by Antlr from the grammars Language1_AST.g and Language1_AST_*.g

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestParser_AST_eval
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "(a(b c d)e)",
         "( a ( b c d ) e )",
         "(a b c d e)",
         "(a b(c d e))",
         "(a (b c) (d e))",
         "(a(b(c(d e))))",
         "(a (b c a) (a (d e) (f a (g a a))))"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language1_ASTLexer lexer = new Language1_ASTLexer(new ANTLRStringStream(exprs[i]));
         Language1_ASTParser parser = new Language1_ASTParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is a tree.
            Language1_ASTParser.stree_return r = parser.stree();
            Tree tree = (Tree)r.getTree();
            //CommonTree tree = (CommonTree)r.getTree();
            System.out.println( tree.toStringTree() );

            // Walk the resulting tree.

            // Create a tree node stream from the resulting tree.
            CommonTreeNodeStream nodes = new CommonTreeNodeStream(tree);

            // Create tree parsers and then launch each tree walker at the start rule "stree".
            Language1_AST_depth walker1 = new Language1_AST_depth(nodes);
            walker1.stree();

            nodes.reset();
            Language1_AST_count_nodes walker2 = new Language1_AST_count_nodes(nodes);
            walker2.stree();

            nodes.reset();
            Language1_AST_count_leaves walker3 = new Language1_AST_count_leaves(nodes);
            walker3.stree();

            nodes.reset();
            Language1_AST_max_degree walker4 = new Language1_AST_max_degree(nodes);
            walker4.stree();

            nodes.reset();
            Language1_AST_count_root walker5 = new Language1_AST_count_root(nodes);
            walker5.stree();

            nodes.reset();
            Language1_AST_DFS_preorder walker6 = new Language1_AST_DFS_preorder(nodes);
            walker6.stree();

            nodes.reset();
            Language1_AST_DFS_inorder walker7 = new Language1_AST_DFS_inorder(nodes);
            walker7.stree();

            nodes.reset();
            Language1_AST_DFS_postorder walker8 = new Language1_AST_DFS_postorder(nodes);
            walker8.stree();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_AST_eval
