/*
  This program tests the four recursive descent parsers
  that we wrote for the grammar in Language-2-infix.txt.
*/

public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "1 + 2 + 3",
         "( 1 + 2 + 3 )",
         "1 + x",
         "2 * ( 3 + 4 )",
         "2 ^ 3 ^ 4",
         "3 * 4 + 5 * 6 + - 4",
         "- ( 3 * 4 )",
         "- 3 ^ ( 1 + 2 )",
         "( 6 % 2 ) + ( 8 % 2 ) + ( 3 % 2 )",
         "( 1 + 2 ) ^ ( 4 * 5 )"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         try
         {
            System.out.println( "Parsing: " + exprs[i] );
            Parser.parse( exprs[i] );

            System.out.println( exprs[i] + " = " + Parser2value.parse(exprs[i]) );

            Tree parseTree = Parser2ParseTree.parse( exprs[i] );
            System.out.println( PrettyPrinter3.prettyPrint( parseTree ) );
            System.out.println( Tree2dot.tree2dot( parseTree ) );

            Tree ast = Parser2AST.parse( exprs[i] );
            System.out.println( PrettyPrinter3.prettyPrint( ast ) );
            System.out.println( "The AST evaluates to -> " + EvaluateAST.evaluate( ast ) );
         }
         catch (ParseException e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser
